Unit AV11C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

function AV11C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var CY :Array of Complex; INCY :Integer;
                var IERR :Integer): Complex;

implementation

function AV11C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var CY :Array of Complex; INCY :Integer;
                var IERR :Integer): Complex;
var
I,IX,IY,M,MP1 :Integer;
X :Real;
CTEMP :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
{ Result -    AV11C  FORTRANe }

{      HAHAEHE }
{      BCEHE CKAPHOO POBEEH BYX BEKTOPOB }
{     *SX SY H N C APAMETPAM PPAEH }
{     *INCX INCY }

{      ABTOP:.O.APYAHH,A.A.KOPOEB,A..AEB }

IERR  := 0;
CTEMP  := Cmplx(0.0,0.0);

{      POBEPKA PABHOCT AAH APAMETPA N }
if ( N  <=  0 ) 
 then goto _70;

{      YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }

X  := 0.0;
if ( INCX  =  1 ) and (  INCY  =  1 ) 
 then goto _20;
IX  := 1 + ((INCX - Abs(INCX)) div 2)*(1 - N);
IY  := 1 + ((INCY - Abs(INCY)) div 2)*(1 - N);

{      BCEHE CKAPHOO POBEEH,KOA APAMETP }
{      PPAEH OTH OT 1 }

for I:=1 to N do
 begin
  CTEMP  := AddC(CTEMP,MulC(CX[IX-1],Conjg(CY[IY-1])));
  IX  := IX + INCX;
  IY  := IY + INCY;
_10:
 end;
goto _60;

{      B.CKAPHOO POBEEH C OMO PABEPHYTOO KA }
{      (KOA APAMETP PPAEH PABH 1) }
_20:
M  := ((N) Mod (5));
if ( M  =  0 ) 
 then goto _40;
for I:=1 to M do
 begin
  CTEMP  := AddC(CTEMP,MulC(CX[I-1],Conjg(CY[I-1])));
_30:
 end;
if ( N  <  5 ) 
 then goto _60;
_40:
MP1  := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  CTEMP  := AddC(AddC(AddC(AddC(AddC(CTEMP,MulC(CX[I-1],Conjg(CY[I-1]))),MulC(CX[I+0],Conjg(
    CY[I+0]))),MulC(CX[I+1],Conjg(CY[I+1]))),MulC(CX[I+2],
    Conjg(CY[I+2]))),MulC(CX[I+3],Conjg(CY[I+3])));
_50:
  inc(I,5);
 end;
_60:
Result := CTEMP;
goto _90;

{      COOEHE O OKE(N HE HATYPAHOE) }
_70:
IERR  := 65;
UTAV10(IERR,6);
Result := Cmplx(0.0,0.0);
goto _90;

{      COOEHE O EPEOHEH }
_80:
{       IERR = 66 }
{       CALL UTAV10(IERR,6) }
{       AV11C = (0.0,0.0) }
_90:
exit;
end;

end.
